***** File description **************************************************
*** File:        extractHeaders.s
***              (This is a part of Norbert Gb's PASSSAVE)
*** Platform:    HP48GX
*** Language:    System-RPL
*** Description: Parameters:
***                <2> list of lists of three strings each
***                <1> index (bint)
***              return-value
***                <2'> copy of <2>
***                <1'> list of SEVEN strings (see definition below)
***              
***              The SEVEN sublists of <2>, beginning at index <1> is 
***              "selected". The first entries of these selected
***              sublists are composed into the list <1'>.
***              If there are less than SEVEN seleced entries, we
***              fill up the list with empty strings.
***              
*** Author:      Norbert Gb (goeb@mathematik.uni-kl.de)
*** Date:        02/2000
***
*** License/Disclaimer **************************************************
*** This program is free software; you can redistribute it and/or  modify
*** it under the terms of the GNU General Public License as published  by
*** the Free Software Foundation; either version 2, or (at  your  option)
*** any later version.
*** 
*** This program is distributed in the hope that it will be  useful,  but
*** WITHOUT  ANY  WARRANTY;  without  even  the   implied   warranty   of
*** MERCHANTABILITY or FITNESS FOR A  PARTICULAR  PURPOSE.  See  the  GNU
*** General Public License for more details.
*** 
*** You should have received a copy of the  GNU  General  Public  License
*** along  with  this  program;  if  not,  write  to  the  Free  Software
*** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
*** USA.
*************************************************************************

*  ( hxs  --> str )
ASSEMBLE
        NIBASC  /HPHP48-D/
RPL
:: 
    CK2NOLASTWD 
*   CK&DISPATCH1 #0051F 
    :: 
       OVER 
       DUP 
       LENCOMP
       ( stack <2>-<1>-<2>-length<2> )
       ( check, if <2> is empty )
       DUP
       #0=
       ITE
       ::
         ( the list <2> is empty )
	 ( drop everything but the list <2> )
	 3DROP
	 ( push a list containing seven empty strings )
	 NULL$
	 SEVEN
	 NDUPN
	 #1+
	 #1-{}N 
       ;
       ::
         ( the list <2> is not empty)
         ROT
         ( stack <2>-<2>-length<2>-<1> )
         DUP 
         SIX
         #+
         ROT
         ( stack <2>-<2>-<1>-[<1>+SEVEN]-length<2> )
         #MIN 
         SUBCOMP
         
         ( stack <2>-[sublist of <2>] )
         DUP
         NULL{}
         SWAP
         LENCOMP
         ( stack <2>-[sublist of <2>]-[empty list]-[length of sublist] )
         
         #1+_ONE_DO (DO)
           ( stack <2>-[sublist of <2>]-[result list, initially empty] )
  	 SWAP
  	 DUP
  	 CDRCOMP
  	 SWAP
  	 ( stack <2>-[sublist of <2>, without first elem]-[sublist of <2>] )
  	 CARCOMP
  	 CARCOMP
           ( stack <2>-[result list]-[sublist of <2>]-[hopefully a string] )
  	 ROTSWAP
  	 >TCOMP
         LOOP
         
         ( remove the -empty- sublist of <2>: )
         SWAP
         DROP
  
         ( now, we should have a list of strings on level 1 --- we have to )
         ( enlarge it to contain exactly SEVEN strings: )
         DUP
         LENCOMP
         SEVEN
         SWAP 
         #-
         DUP
         ZERO
         #>
         ITE
           ::
             #1+_ONE_DO (DO)
               NULL$
               >TCOMP
             LOOP
           ;
  	 ::
  	   DROP
  	 ;
       ;
    ;
;
