***** File description **************************************************
*** File:        passSave.s
***              (This is a part of Norbert Gb's PASSSAVE)
*** Platform:    HP48GX
*** Language:    System-RPL
*** Description: That's the main-function (so it's to called by the user).
***              This function has neither input nor output. It receives
***              the password-data from the 'PASSDATA.pws' variable, where
***              it is stored encrypted. Then the password for en-/decrypting
***              the data is asked for. The data is decrypted and both
***              data and password remain on the stack. 
***                Then, we enter the main-loop, where the header-lines
***              of the password-records are displayed and the user may
***              choose one of the records to be displayed in full. Here
***              it is also possible to add/change/delete records and to
***              change the password.
***                After exiting the main-loop, the data is encrypted and
***              stored to 'PASSDATA.pws'. The stack is left empty.
***              
*** Author:      Norbert Gb (goeb@mathematik.uni-kl.de)
*** Date:        02/2000
***
*** License/Disclaimer **************************************************
*** This program is free software; you can redistribute it and/or  modify
*** it under the terms of the GNU General Public License as published  by
*** the Free Software Foundation; either version 2, or (at  your  option)
*** any later version.
*** 
*** This program is distributed in the hope that it will be  useful,  but
*** WITHOUT  ANY  WARRANTY;  without  even  the   implied   warranty   of
*** MERCHANTABILITY or FITNESS FOR A  PARTICULAR  PURPOSE.  See  the  GNU
*** General Public License for more details.
*** 
*** You should have received a copy of the  GNU  General  Public  License
*** along  with  this  program;  if  not,  write  to  the  Free  Software
*** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
*** USA.
*************************************************************************

*  ( hxs  --> str )
ASSEMBLE
=DoRomptr EQU #02FEF
        NIBASC  /HPHP48-D/
RPL
:: 
    CK0NOLASTWD 
    :: 
      "- Data decryption -"
      ID getPasswd 
      ( recall the data )
      ' ID PASSDATA.pws @
      ITE
      ::
        ( the variable exists )
        OVER
  
        ( please wait... )
        BlankDA12 
        "Decrypting"
        DISPROW1
        "Please wait..."
        BIGDISPROW2
        
        ( call the LRD-decryption function from the md5lib-library )
        ID decrypt
      ;
      ::
        ( the variable does not exist )
	NULL{}
	TRUE   ( creating new data is like entering the correct password! )
      ;

      ITE
      ::
        ( that's been the right passwd )

	( stack: [passwd]-[decrypted data] ) 
	ID mainLoop
	( stack: [new passwd]-[new decrypted data]-[flag: save?] )

	( if the main-loop was not left by CANCEL, we store the data )
	ITE
	::
	  ( the main loop was left by quit'n'save )
          ( please wait... )
          BlankDA12 
	  "Encrypting"
	  DISPROW1
          "Please wait..."
          BIGDISPROW2
	  
	  ( stack: [new passwd]-[new decrypted data] )
	  SWAP 
	  ID encrypt
	  
	  ' ID PASSDATA.pws
	  STO
	;
	::
	  ( the main loop was cancelled )
	  2DROP
	;
      ;
      ::
        ( that's been the wrong passwd )
	( stack: [passwd]-["decrypted" data] )
	2DROP
	BlankDA12

	"Wrong password!"
	BIGDISPROW2
	%2
	dowait
	
      ;
      ( stack: [passwd]-[data] )
    ;
;
